Index: NEMO/trunk/src/OCE/ZDF/zdfosm.F90
===================================================================
--- NEMO/trunk/src/OCE/ZDF/zdfosm.F90	(revision 14903)
+++ NEMO/trunk/src/OCE/ZDF/zdfosm.F90	(revision 14921)
@@ -2301,88 +2700,220 @@
       !! References: Fox-Kemper et al., JPO, 38, 1145-1165, 2008
       !!             Fox-Kemper and Ferrari, JPO, 38, 1166-1179, 2008
-
-
-      REAL(wp), DIMENSION(jpi,jpj)     :: dbdx_mle, dbdy_mle ! MLE horiz gradients at u & v points
-      REAL(wp), DIMENSION(jpi,jpj)     :: zdbds_mle ! Magnitude of horizontal buoyancy gradient.
-      REAL(wp), DIMENSION(jpi,jpj)     :: zmld ! ==  estimated FK BLD used for MLE horiz gradients  == !
-      REAL(wp), DIMENSION(jpi,jpj)     :: zdtdx, zdtdy, zdsdx, zdsdy
-
-      INTEGER  ::   ji, jj, jk          ! dummy loop indices
-      INTEGER  ::   ii, ij, ik, ikmax   ! local integers
-      REAL(wp)                         :: zc
-      REAL(wp)                         :: zN2_c           ! local buoyancy difference from 10m value
-      REAL(wp), DIMENSION(jpi,jpj)     :: ztm, zsm, zLf_NH, zLf_MH
-      REAL(wp), DIMENSION(jpi,jpj,jpts):: ztsm_midu, ztsm_midv, zabu, zabv
-      REAL(wp), DIMENSION(jpi,jpj)     :: zmld_midu, zmld_midv
-!!----------------------------------------------------------------------
-      !
-      !                                      !==  MLD used for MLE  ==!
-
-      mld_prof(:,:)  = nlb10               ! Initialization to the number of w ocean point
-      zmld(:,:)  = 0._wp               ! here hmlp used as a dummy variable, integrating vertically N^2
-      zN2_c = grav * rn_osm_mle_rho_c * r1_rho0   ! convert density criteria into N^2 criteria
-      DO_3D( 1, 1, 1, 1, nlb10, jpkm1 )
+      !!
+      !!----------------------------------------------------------------------
+      INTEGER,                            INTENT(in   ) ::   Kmm          ! Time-level index
+      REAL(wp), DIMENSION(A2D(nn_hls)),   INTENT(  out) ::   pmld         ! == Estimated FK BLD used for MLE horizontal gradients == !
+      REAL(wp), DIMENSION(A2D(nn_hls)),   INTENT(inout) ::   pdtdx        ! Horizontal gradient for Fox-Kemper parametrization
+      REAL(wp), DIMENSION(A2D(nn_hls)),   INTENT(inout) ::   pdtdy        ! Horizontal gradient for Fox-Kemper parametrization
+      REAL(wp), DIMENSION(A2D(nn_hls)),   INTENT(inout) ::   pdsdx        ! Horizontal gradient for Fox-Kemper parametrization
+      REAL(wp), DIMENSION(A2D(nn_hls)),   INTENT(inout) ::   pdsdy        ! Horizontal gradient for Fox-Kemper parametrization
+      REAL(wp), DIMENSION(A2D(nn_hls-1)), INTENT(inout) ::   pdbds_mle    ! Magnitude of horizontal buoyancy gradient
+      !!
+      INTEGER                               ::   ji, jj, jk   ! Dummy loop indices
+      INTEGER,  DIMENSION(A2D(nn_hls))      ::   jk_mld_prof  ! Base level of MLE layer
+      INTEGER                               ::   ikt, ikmax   ! Local integers      
+      REAL(wp)                              ::   zc
+      REAL(wp)                              ::   zN2_c        ! Local buoyancy difference from 10m value
+      REAL(wp), DIMENSION(A2D(nn_hls))      ::   ztm
+      REAL(wp), DIMENSION(A2D(nn_hls))      ::   zsm
+      REAL(wp), DIMENSION(A2D(nn_hls),jpts) ::   ztsm_midu
+      REAL(wp), DIMENSION(A2D(nn_hls),jpts) ::   ztsm_midv
+      REAL(wp), DIMENSION(A2D(nn_hls),jpts) ::   zabu
+      REAL(wp), DIMENSION(A2D(nn_hls),jpts) ::   zabv
+      REAL(wp), DIMENSION(A2D(nn_hls))      ::   zmld_midu
+      REAL(wp), DIMENSION(A2D(nn_hls))      ::   zmld_midv
+      !!----------------------------------------------------------------------
+      !
+      ! ==  MLD used for MLE  ==!
+      DO_2D( nn_hls, nn_hls, nn_hls, nn_hls )
+         jk_mld_prof(ji,jj) = nlb10    ! Initialization to the number of w ocean point
+         pmld(ji,jj)        = 0.0_wp   ! Here hmlp used as a dummy variable, integrating vertically N^2
+      END_2D
+      zN2_c = grav * rn_osm_mle_rho_c * r1_rho0   ! Convert density criteria into N^2 criteria
+      DO_3D( nn_hls, nn_hls, nn_hls, nn_hls, nlb10, jpkm1 )
          ikt = mbkt(ji,jj)
-         zmld(ji,jj) = zmld(ji,jj) + MAX( rn2b(ji,jj,jk) , 0._wp ) * e3w(ji,jj,jk,Kmm)
-         IF( zmld(ji,jj) < zN2_c )   mld_prof(ji,jj) = MIN( jk , ikt ) + 1   ! Mixed layer level
+         pmld(ji,jj) = pmld(ji,jj) + MAX( rn2b(ji,jj,jk), 0.0_wp ) * e3w(ji,jj,jk,Kmm)
+         IF( pmld(ji,jj) < zN2_c ) jk_mld_prof(ji,jj) = MIN( jk , ikt ) + 1   ! Mixed layer level
       END_3D
-      DO_2D( 1, 1, 1, 1 )
-         mld_prof(ji,jj) = MAX(mld_prof(ji,jj),ibld(ji,jj))
-         zmld(ji,jj) = gdepw(ji,jj,mld_prof(ji,jj),Kmm)
-      END_2D
-      ! ensure mld_prof .ge. ibld
-      !
-      ikmax = MIN( MAXVAL( mld_prof(:,:) ), jpkm1 )                  ! max level of the computation
-      !
-      ztm(:,:) = 0._wp
-      zsm(:,:) = 0._wp
-      DO_3D( 1, 1, 1, 1, 1, ikmax )
-         zc = e3t(ji,jj,jk,Kmm) * REAL( MIN( MAX( 0, mld_prof(ji,jj)-jk ) , 1  )  )    ! zc being 0 outside the ML t-points
+      DO_2D( nn_hls, nn_hls, nn_hls, nn_hls )
+         jk_mld_prof(ji,jj) = MAX( jk_mld_prof(ji,jj), nbld(ji,jj) )   ! Ensure jk_mld_prof .ge. nbld
+         pmld(ji,jj)     = gdepw(ji,jj,jk_mld_prof(ji,jj),Kmm)
+      END_2D
+      DO_2D_OVR( nn_hls-1, nn_hls-1, nn_hls-1, nn_hls-1 )
+         mld_prof(ji,jj) = jk_mld_prof(ji,jj)
+      END_2D
+      !
+      ikmax = MIN( MAXVAL( jk_mld_prof(A2D(nn_hls)) ), jpkm1 )   ! Max level of the computation
+      ztm(:,:) = 0.0_wp
+      zsm(:,:) = 0.0_wp
+      DO_3D( nn_hls, nn_hls, nn_hls, nn_hls, 1, ikmax )
+         zc = e3t(ji,jj,jk,Kmm) * REAL( MIN( MAX( 0, jk_mld_prof(ji,jj) - jk ), 1  ), KIND=wp )   ! zc being 0 outside the ML
+         !                                                                                        !    t-points
          ztm(ji,jj) = ztm(ji,jj) + zc * ts(ji,jj,jk,jp_tem,Kmm)
          zsm(ji,jj) = zsm(ji,jj) + zc * ts(ji,jj,jk,jp_sal,Kmm)
       END_3D
-      ! average temperature and salinity.
-      ztm(:,:) = ztm(:,:) / MAX( e3t(:,:,1,Kmm), zmld(:,:) )
-      zsm(:,:) = zsm(:,:) / MAX( e3t(:,:,1,Kmm), zmld(:,:) )
-      ! calculate horizontal gradients at u & v points
-
-      DO_2D( 1, 0, 0, 0 )
-         zdtdx(ji,jj) = ( ztm(ji+1,jj) - ztm( ji,jj) )  * umask(ji,jj,1) / e1u(ji,jj)
-         zdsdx(ji,jj) = ( zsm(ji+1,jj) - zsm( ji,jj) )  * umask(ji,jj,1) / e1u(ji,jj)
-         zmld_midu(ji,jj) = 0.25_wp * (zmld(ji+1,jj) + zmld( ji,jj))
-         ztsm_midu(ji,jj,jp_tem) = 0.5_wp * ( ztm(ji+1,jj) + ztm( ji,jj) )
-         ztsm_midu(ji,jj,jp_sal) = 0.5_wp * ( zsm(ji+1,jj) + zsm( ji,jj) )
-      END_2D
-
-      DO_2D( 0, 0, 1, 0 )
-         zdtdy(ji,jj) = ( ztm(ji,jj+1) - ztm( ji,jj) ) * vmask(ji,jj,1) / e1v(ji,jj)
-         zdsdy(ji,jj) = ( zsm(ji,jj+1) - zsm( ji,jj) ) * vmask(ji,jj,1) / e1v(ji,jj)
-         zmld_midv(ji,jj) = 0.25_wp * (zmld(ji,jj+1) + zmld( ji,jj))
-         ztsm_midv(ji,jj,jp_tem) = 0.5_wp * ( ztm(ji,jj+1) + ztm( ji,jj) )
-         ztsm_midv(ji,jj,jp_sal) = 0.5_wp * ( zsm(ji,jj+1) + zsm( ji,jj) )
-      END_2D
-
-      CALL eos_rab(ztsm_midu, zmld_midu, zabu, Kmm)
-      CALL eos_rab(ztsm_midv, zmld_midv, zabv, Kmm)
-
-      DO_2D( 1, 0, 0, 0 )
-         dbdx_mle(ji,jj) = grav*(zdtdx(ji,jj)*zabu(ji,jj,jp_tem) - zdsdx(ji,jj)*zabu(ji,jj,jp_sal))
-      END_2D
-      DO_2D( 0, 0, 1, 0 )
-         dbdy_mle(ji,jj) = grav*(zdtdy(ji,jj)*zabv(ji,jj,jp_tem) - zdsdy(ji,jj)*zabv(ji,jj,jp_sal))
-      END_2D
-
-      DO_2D( 0, 0, 0, 0 )
-        ztmp =  r1_ft(ji,jj) *  MIN( 111.e3_wp , e1u(ji,jj) ) / rn_osm_mle_lf
-        zdbds_mle(ji,jj) = SQRT( 0.5_wp * ( dbdx_mle(ji,jj) * dbdx_mle(ji,jj) + dbdy_mle(ji,jj) * dbdy_mle(ji,jj) &
-             & + dbdx_mle(ji-1,jj) * dbdx_mle(ji-1,jj) + dbdy_mle(ji,jj-1) * dbdy_mle(ji,jj-1) ) )
-      END_2D
-
- END SUBROUTINE zdf_osm_zmld_horizontal_gradients
-  SUBROUTINE zdf_osm_mle_parameters( mld_prof, hmle, zhmle, zvel_mle, zdiff_mle )
-      !!----------------------------------------------------------------------
-      !!                  ***  ROUTINE zdf_osm_mle_parameters  ***
-      !!
-      !! ** Purpose :   Timesteps the mixed layer eddy depth, hmle and calculates the mixed layer eddy fluxes for buoyancy, heat and salinity.
+      ! Average temperature and salinity
+      DO_2D( nn_hls, nn_hls, nn_hls, nn_hls )
+         ztm(ji,jj) = ztm(ji,jj) / MAX( e3t(ji,jj,1,Kmm), pmld(ji,jj) )
+         zsm(ji,jj) = zsm(ji,jj) / MAX( e3t(ji,jj,1,Kmm), pmld(ji,jj) )
+      END_2D
+      ! Calculate horizontal gradients at u & v points
+      zmld_midu(:,:)   =  0.0_wp
+      ztsm_midu(:,:,:) = 10.0_wp
+      DO_2D( nn_hls, nn_hls-1, nn_hls-1, nn_hls-1 )
+         pdtdx(ji,jj)            = ( ztm(ji+1,jj) - ztm(ji,jj) )  * umask(ji,jj,1) / e1u(ji,jj)
+         pdsdx(ji,jj)            = ( zsm(ji+1,jj) - zsm(ji,jj) )  * umask(ji,jj,1) / e1u(ji,jj)
+         zmld_midu(ji,jj)        = 0.25_wp * ( pmld(ji+1,jj) + pmld(ji,jj))
+         ztsm_midu(ji,jj,jp_tem) =  0.5_wp * ( ztm( ji+1,jj)  + ztm( ji,jj) )
+         ztsm_midu(ji,jj,jp_sal) =  0.5_wp * ( zsm( ji+1,jj)  + zsm( ji,jj) )
+      END_2D
+      zmld_midv(:,:)   =  0.0_wp
+      ztsm_midv(:,:,:) = 10.0_wp
+      DO_2D( nn_hls-1, nn_hls-1, nn_hls, nn_hls-1 )
+         pdtdy(ji,jj)            = ( ztm(ji,jj+1) - ztm(ji,jj) ) * vmask(ji,jj,1) / e1v(ji,jj)
+         pdsdy(ji,jj)            = ( zsm(ji,jj+1) - zsm(ji,jj) ) * vmask(ji,jj,1) / e1v(ji,jj)
+         zmld_midv(ji,jj)        = 0.25_wp * ( pmld(ji,jj+1) + pmld( ji,jj) )
+         ztsm_midv(ji,jj,jp_tem) =  0.5_wp * ( ztm( ji,jj+1)  + ztm( ji,jj) )
+         ztsm_midv(ji,jj,jp_sal) =  0.5_wp * ( zsm( ji,jj+1)  + zsm( ji,jj) )
+      END_2D
+      CALL eos_rab( ztsm_midu, zmld_midu, zabu, Kmm )
+      CALL eos_rab( ztsm_midv, zmld_midv, zabv, Kmm )
+      DO_2D_OVR( nn_hls, nn_hls-1, nn_hls-1, nn_hls-1 )
+         dbdx_mle(ji,jj) = grav * ( pdtdx(ji,jj) * zabu(ji,jj,jp_tem) - pdsdx(ji,jj) * zabu(ji,jj,jp_sal) )
+      END_2D
+      DO_2D_OVR( nn_hls-1, nn_hls-1, nn_hls, nn_hls-1 )
+         dbdy_mle(ji,jj) = grav * ( pdtdy(ji,jj) * zabv(ji,jj,jp_tem) - pdsdy(ji,jj) * zabv(ji,jj,jp_sal) )
+      END_2D
+      DO_2D( nn_hls-1, nn_hls-1, nn_hls-1, nn_hls-1 )
+         pdbds_mle(ji,jj) = SQRT( 0.5_wp * ( dbdx_mle(ji,  jj) * dbdx_mle(ji,  jj) + dbdy_mle(ji,jj  ) * dbdy_mle(ji,jj  ) +   &
+            &                                dbdx_mle(ji-1,jj) * dbdx_mle(ji-1,jj) + dbdy_mle(ji,jj-1) * dbdy_mle(ji,jj-1) ) )
+      END_2D
+      !
+   END SUBROUTINE zdf_osm_zmld_horizontal_gradients
+
+   SUBROUTINE zdf_osm_osbl_state_fk( Kmm, pwb_fk, phbl, phmle, pwb_ent,   &
+      &                              pdbds_mle )
+      !!---------------------------------------------------------------------
+      !!               ***  ROUTINE zdf_osm_osbl_state_fk  ***
+      !!
+      !! ** Purpose : Determines the state of the OSBL and MLE layer. Info is
+      !!              returned in the logicals l_pyc, l_flux and ldmle. Used
+      !!              with Fox-Kemper scheme.
+      !!                l_pyc  :: determines whether pycnocline flux-grad
+      !!                          relationship needs to be determined
+      !!                l_flux :: determines whether effects of surface flux
+      !!                          extend below the base of the OSBL
+      !!                ldmle  :: determines whether the layer with MLE is
+      !!                          increasing with time or if base is relaxing
+      !!                          towards hbl
+      !!
+      !! ** Method  :
+      !!
+      !!----------------------------------------------------------------------      
+      INTEGER,                            INTENT(in   ) ::   Kmm         ! Time-level index
+      REAL(wp), DIMENSION(A2D(nn_hls-1)), INTENT(inout) ::   pwb_fk
+      REAL(wp), DIMENSION(A2D(nn_hls-1)), INTENT(in   ) ::   phbl        ! BL depth
+      REAL(wp), DIMENSION(A2D(nn_hls-1)), INTENT(in   ) ::   phmle       ! MLE depth
+      REAL(wp), DIMENSION(A2D(nn_hls-1)), INTENT(in   ) ::   pwb_ent     ! Buoyancy entrainment flux
+      REAL(wp), DIMENSION(A2D(nn_hls-1)), INTENT(in   ) ::   pdbds_mle   ! Magnitude of horizontal buoyancy gradient
+      !!
+      INTEGER                            ::   ji, jj, jk        ! Dummy loop indices
+      REAL(wp), DIMENSION(A2D(nn_hls-1)) ::   znd_param
+      REAL(wp)                           ::   zthermal, zbeta
+      REAL(wp)                           ::   zbuoy
+      REAL(wp)                           ::   ztmp
+      REAL(wp)                           ::   zpe_mle_layer
+      REAL(wp)                           ::   zpe_mle_ref
+      REAL(wp)                           ::   zdbdz_mle_int
+      !!----------------------------------------------------------------------      
+      !
+      znd_param(:,:) = 0.0_wp
+      !
+      DO_2D_OVR( nn_hls-1, nn_hls-1, nn_hls-1, nn_hls-1 )
+         ztmp =  r1_ft(ji,jj) *  MIN( 111.e3_wp , e1u(ji,jj) ) / rn_osm_mle_lf
+         pwb_fk(ji,jj) = rn_osm_mle_ce * hmle(ji,jj) * hmle(ji,jj) * ztmp * pdbds_mle(ji,jj) * pdbds_mle(ji,jj)
+      END_2D
+      !
+      DO_2D_OVR( nn_hls-1, nn_hls-1, nn_hls-1, nn_hls-1 )
+         !
+         IF ( l_conv(ji,jj) ) THEN
+            IF ( phmle(ji,jj) > 1.2_wp * phbl(ji,jj) ) THEN
+               av_t_mle(ji,jj) = ( av_t_mle(ji,jj) * phmle(ji,jj) - av_t_bl(ji,jj) * phbl(ji,jj) ) / ( phmle(ji,jj) - phbl(ji,jj) )
+               av_s_mle(ji,jj) = ( av_s_mle(ji,jj) * phmle(ji,jj) - av_s_bl(ji,jj) * phbl(ji,jj) ) / ( phmle(ji,jj) - phbl(ji,jj) )
+               av_b_mle(ji,jj) = ( av_b_mle(ji,jj) * phmle(ji,jj) - av_b_bl(ji,jj) * phbl(ji,jj) ) / ( phmle(ji,jj) - phbl(ji,jj) )
+               zdbdz_mle_int = ( av_b_bl(ji,jj) - ( 2.0_wp * av_b_mle(ji,jj) - av_b_bl(ji,jj) ) ) / ( phmle(ji,jj) - phbl(ji,jj) )
+               ! Calculate potential energies of actual profile and reference profile
+               zpe_mle_layer = 0.0_wp
+               zpe_mle_ref   = 0.0_wp
+               zthermal = rab_n(ji,jj,1,jp_tem)
+               zbeta    = rab_n(ji,jj,1,jp_sal)
+               DO jk = nbld(ji,jj), mld_prof(ji,jj)
+                  zbuoy         = grav * ( zthermal * ts(ji,jj,jk,jp_tem,Kmm) - zbeta * ts(ji,jj,jk,jp_sal,Kmm) )
+                  zpe_mle_layer = zpe_mle_layer + zbuoy * gdepw(ji,jj,jk,Kmm) * e3w(ji,jj,jk,Kmm)
+                  zpe_mle_ref   = zpe_mle_ref   + ( av_b_bl(ji,jj) - zdbdz_mle_int * ( gdepw(ji,jj,jk,Kmm) - phbl(ji,jj) ) ) *   &
+                     &                            gdepw(ji,jj,jk,Kmm) * e3w(ji,jj,jk,Kmm)
+               END DO
+               ! Non-dimensional parameter to diagnose the presence of thermocline
+               znd_param(ji,jj) = ( zpe_mle_layer - zpe_mle_ref ) * ABS( ff_t(ji,jj) ) /   &
+                  &               ( MAX( pwb_fk(ji,jj), 1e-10 ) * phmle(ji,jj) )
+            END IF
+         END IF
+         !
+      END_2D
+      !
+      ! Diagnosis
+      DO_2D_OVR( nn_hls-1, nn_hls-1, nn_hls-1, nn_hls-1 )
+         !
+         IF ( l_conv(ji,jj) ) THEN
+            IF ( -2.0_wp * pwb_fk(ji,jj) / pwb_ent(ji,jj) > 0.5_wp ) THEN
+               IF ( phmle(ji,jj) > 1.2_wp * phbl(ji,jj) ) THEN   ! MLE layer growing
+                  IF ( znd_param (ji,jj) > 100.0_wp ) THEN   ! Thermocline present
+                     l_flux(ji,jj) = .FALSE.
+                     l_mle(ji,jj)  = .FALSE.
+                  ELSE   ! Thermocline not present
+                     l_flux(ji,jj) = .TRUE.
+                     l_mle(ji,jj)  = .TRUE.
+                  ENDIF  ! znd_param > 100
+                  !
+                  IF ( av_db_bl(ji,jj) < rn_osm_bl_thresh ) THEN
+                     l_pyc(ji,jj) = .FALSE.
+                  ELSE
+                     l_pyc(ji,jj) = .TRUE.
+                  ENDIF
+               ELSE   ! MLE layer restricted to OSBL or just below
+                  IF ( av_db_bl(ji,jj) < rn_osm_bl_thresh ) THEN   ! Weak stratification MLE layer can grow
+                     l_pyc(ji,jj)  = .FALSE.
+                     l_flux(ji,jj) = .TRUE.
+                     l_mle(ji,jj)  = .TRUE.
+                  ELSE   ! Strong stratification
+                     l_pyc(ji,jj)  = .TRUE.
+                     l_flux(ji,jj) = .FALSE.
+                     l_mle(ji,jj)  = .FALSE.
+                  END IF   ! av_db_bl < rn_mle_thresh_bl and
+               END IF   ! phmle > 1.2 phbl
+            ELSE
+               l_pyc(ji,jj)  = .TRUE.
+               l_flux(ji,jj) = .FALSE.
+               l_mle(ji,jj)  = .FALSE.
+               IF ( av_db_bl(ji,jj) < rn_osm_bl_thresh ) l_pyc(ji,jj) = .FALSE.
+            END IF   !  -2.0 * pwb_fk(ji,jj) / pwb_ent > 0.5
+         ELSE   ! Stable Boundary Layer
+            l_pyc(ji,jj)  = .FALSE.
+            l_flux(ji,jj) = .FALSE.
+            l_mle(ji,jj)  = .FALSE.
+         END IF   ! l_conv
+         !
+      END_2D
+      !
+   END SUBROUTINE zdf_osm_osbl_state_fk
+
+   SUBROUTINE zdf_osm_mle_parameters( Kmm, pmld, phmle, pvel_mle, pdiff_mle,   &
+      &                               pdbds_mle, phbl, pwb0tot )
+      !!----------------------------------------------------------------------
+      !!               ***  ROUTINE zdf_osm_mle_parameters  ***
+      !!
+      !! ** Purpose : Timesteps the mixed layer eddy depth, hmle and calculates
+      !!              the mixed layer eddy fluxes for buoyancy, heat and
+      !!              salinity.
       !!
       !! ** Method  :
